<?php
class SolsController extends AppController {

	var $name = 'Sols';
	var $helpers = array('Html', 'Form' );

        function beforeFilter() {
                $groupid = $this->Session->read('group');
                $polid = $this->Session->read('pol');
                if (!$groupid || !$polid) {
                    $this->Session->delete('sol');
                    $this->redirect('/users/login');
                }
        }

 	function index() {
                $polid = $this->Session->read('pol');
		$this->Sol->recursive = 0;
                $sols = $this->Sol->findAll("pol_id = $polid", NULL, 'Sol.id DESC');
		$this->set('sols', $sols);
                $this->set('menu_left', array(array('label' => 'New SoL', 'link' => '/sols/add')));
                if (!empty($sols['0']['Sol']['id']))
                    $this->Session->write('last_sol_id', $sols['0']['Sol']['id']);
	}

	function view($id = null) {
		if (!$id) {
			$this->Session->setFlash('Invalid id for Sol.');
			$this->redirect('/sols/index');
		}
		$this->Sol->recursive = 1;
                $sol = $this->Sol->read(null, $id);
                if ($sol['Sol']['pol_id'] == $this->Session->read('pol')) {
                    // calcolo delle email, della dimensione ecc
                    $eml_received = 0;
                    $eml_sended = 0;
                    $eml_unread = 0;
                    $eml_tsize = 0;
                    $eml_total = 0;
                    foreach($sol['Email'] as $email) {
                        if ($email['receive']) {
                            $eml_received++;
                        }
                        else {
                            $eml_sended++;
                        }
                        $eml_tsize += $email['data_size'];
                        if (!$email['first_visualization_user_id']) {
                            $eml_unread++;
                        }
                        $eml_total++;
                    }
                    // calcolo dei file, della dimensione ecc
                    $file_viewed = 0;
                    $file_tsize = 0;
                    $file_total = 0;
                    foreach($sol['File'] as $file) {
                        $file_tsize += $file['data_size'];
                        if ($file['first_visualization_user_id']) {
                            $file_viewed++;
                        }
                        $file_total++;
                    }

                    $last_sol_id = $this->Session->read('last_sol_id');
                    if ($last_sol_id == $id)
                        $this->set('last_sol', 1);
                    else
                        $this->set('last_sol', 0);
                    $this->set('sol', $sol);
                    $this->set('eml_received', $eml_received);
                    $this->set('eml_sended', $eml_sended);
                    $this->set('eml_unread', $eml_unread);
                    $this->set('eml_total', $eml_total);
                    $this->set('eml_tsize', $eml_tsize);
                    $this->set('file_viewed', $file_viewed);
                    $this->set('file_total', $file_total);
                    $this->set('file_tsize', $file_tsize);
                    $this->set('menu_left', array( array('label' => 'Sols', 'link' => '/sols/index'),
                                                   array('label' => '', 'link' => ''),
                                                   array('label' => 'Email', 'link' => '/emails/index'),
                                                   array('label' => 'Sip', 'link' => '/sips/index'),
                                                   //array('label' => 'File', 'link' => '/files/index'),
                                                   array('label' => 'Web', 'link' => '/webs/index'),
                                   ));
                    $this->set('refresh_time', 30);
                    $this->Session->write('sol', $id);
                }
                else {
                    $this->redirect('/pols/index');
                }
	}

	function add() {
		if (empty($this->data)) {
			$this->render();
		} else {
			$this->cleanUpFields();
                        $polid = $this->Session->read('pol');
                        $this->data['Sol']['pol_id'] = $polid;
			if($this->Sol->save($this->data)) {
                                $this->Session->setFlash('The Sol has been created');
				$this->redirect('/sols/index');
                                system('cd /xplico; /xplico/script/create_session.sh '. $polid . ' ' . $this->Sol->getLastInsertId());
			} else {
				$this->Session->setFlash('Please correct errors below.');
			}
		}
	}

	function delete($id = null) {
		if (!$id) {
			$this->Session->setFlash('Invalid id for Sol');
			$this->redirect('/sols/index');
		}
                $sol = $this->Sol->read(null, $id);
                if ($sol['Sol']['pol_id'] != $this->Session->read('pol')) {
                        $this->Session->setFlash('Invalid id for Sol');
			$this->redirect('/sols/index');
                }
		if ($this->Sol->del($id)) {
                        // delete directory
                        $sol_dir = '/xplico/pol_'.$this->Session->read('pol').'/sol_'.$id;
                        system('rm -rf '.$sol_dir);
			$this->Session->setFlash('The Sol deleted');
			$this->redirect('/sols/index');
		}
	}

        function pcap() {
            if (!empty($this->params['form']) &&
                is_uploaded_file($this->params['form']['File']['tmp_name'])) {
                $filedec = '/xplico/pol_'.$this->Session->read('pol').'/sol_'.$this->Session->read('sol').'/new/'.$this->params['form']['File']['name'];
                move_uploaded_file($this->params['form']['File']['tmp_name'], $filedec);
                $this->Session->setFlash('File uploaded, wait start decoding...');
                $this->redirect('/sols/view/'.$this->Session->read('sol'));
            }
            else {
                $this->Session->setFlash('Upload Failed');
                $this->redirect('/sols/index');
            }
        }
}
?>
