<?php
uses('sanitize');
class UsersController extends AppController
{
    var $helpers = array('Html', 'Form', 'Javascript', 'Ajax' );
    var $components = array('RequestHandler', 'Security');

    function beforeFilter() {
        if (!empty($this->data)) {
            $this->Security->requirePost('register');
            $this->Security->requirePost('login');
        }
        $this->Security->blackHoleCallback='invalid';
    }

    function invalid() {
        header('HTTP/x 400 Bad Request');
        echo('<h1>Tor: 400 Bad Request</h1>');
        echo('<p>We\'re sorry - there has been a problem processing your request.  Please try submitting the form again.</p>');
        die();
    }

    function about() {

    }

    function help() {

    }

    function register() {
        $this->set('username_error', 'Username must be between 6 and 40 characters.');
        if (!empty($this->data)) {
            $san = new Sanitize();
            $this->data['User']['username']   = $san->paranoid($this->data['User']['username']);
            $this->data['User']['email']      = $san->paranoid($this->data['User']['email'],
                                                               array('@', '.', '-', '+'));
            
            $this->data['User']['first_name'] = $san->paranoid($this->data['User']['first_name'],
                                                               array('\'', ' '));
            
            $this->data['User']['last_name']  = $san->paranoid($this->data['User']['last_name'],
                                                               array('\'', ' '));
            if ($this->User->validates($this->data)) {
                if ($this->User->findByUsername($this->data['User']['username'])) {
                    $this->User->invalidate('username');
                    $this->set('username_error', 'User already exists.');
                } else {
                    if ($this->User->findByEmail($this->data['User']['email'])) {
                        $this->User->invalidate('email');
                    }
                    else {
                        // create group
                        $this->data['Group']['name'] = $this->data['User']['username'];
                        $this->User->Group->save($this->data);
                        $this->data['User']['password'] = md5($this->data['User']['password']);
                        $this->data['User']['em_key'] = md5($this->data['User']['email'].'Xplico');
                        $this->data['User']['group_id'] = $this->User->Group->getID();
                        if ($this->User->save($this->data)) {
                            // send email to confirm registration
                            mail($this->data['User']['email'], "Xplico - Account Activation Request",
                                 "To confirm click your personal link below\n http://demo.xplico.org:71/users/registerConfirm?key=".$this->data['User']['em_key']."\n",
                                 "From: register@xplico.org");
                            $this->Session->setFlash('To complete registration wait the e.mail');
                            $this->redirect('/users/index');
                        } else {
                            $this->flash('There was a problem saving this information', '/users/register');
                        }
                    }
                }
            } else {
                $this->validateErrors($this->User);
            }
        }
    }
    
    function registerConfirm() {
        if (!empty($this->params['url']['key'])) {
            $san = new Sanitize();
            $em_key = $this->params['url']['key'];
            $em_key = $san->paranoid($em_key);
            $results = $this->User->findByEm_key($em_key);
            if (!empty($results)) {
                $results['User']['em_checked'] = 1;
                $this->User->save($results);
            } else {
                $this->redirect('/users/login');
            }
        }
        else {
            $this->redirect('/users/login');
        }
    }

    function knownusers() {
  	$this->set('knownusers', $this->User->findAll(null, array('id', 'username', 'first_name', 'last_name', 'last_login', 'email'), 'id DESC'));
    }
    
    function resend_reg() {
        // reinvio della conferma della registrazione
        if (!empty($this->data)) {
            $user = $this->User->findByEmail($this->data['User']['email']);
            if (!empty($user)) {
                $em_key = $user['User']['em_key'];
                // send email to confirm registration
                mail($this->data['User']['email'], "Xplico - Account Activation Request",
                     "To confirm click your personal link below\n http://demo.xplico.org:71/users/registerConfirm?key=".$em_key."\n",
                     "From: register@xplico.org");
                $this->Session->setFlash('To complete registration wait the e.mail');
            }
            $this->redirect('/users/index');
        }
    }

    function login() {
        $username = $this->Session->read('user');
        if ($username) {
            $this->redirect('/pols/index');
        }
        $this->set('error', false);
        if ($this->data) {
            $san = new Sanitize();
            $cleaned_username = $san->paranoid($this->data['User']['username']);
            $results = $this->User->findByUsername($cleaned_username);
            if ($results && $results['User']['password'] == md5($this->data['User']['password']) && $results['User']['em_checked'] == 1) {
                $this->Session->write('userid', $results['User']['id']);
                $this->Session->write('user', $cleaned_username);
                $this->Session->write('last_login', $results['User']['last_login']);
                $this->Session->write('group', $results['User']['group_id']);
                $results['User']['last_login'] = date("Y-m-d H:i:s");
                $this->User->save($results);
                $this->redirect('/pols/index');
            } else {
                $this->set('error', true);
            }
        }
    }
    
    function logout() {
        $this->Session->delete('userid');
        $this->Session->delete('user');
        $this->Session->delete('group');
        $this->redirect('/users/login');
    }
    
    function index() {
        $username = $this->Session->read('user');
        if ($username || !empty($this->data)) {
            $this->redirect('/pols/index');
        } else {
            $this->redirect('/users/login');
        }
    }
}
?>
